<?php
/**
 * @filename Tokenizer.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 15:22
 */


namespace JerryYan\DSL\Tokenizer;


use ArrayIterator;
use JerryYan\DSL\Reader\ReaderInterface;
use JerryYan\DSL\Token\TokenFactory;

class Tokenizer extends TokenizerInterface
{

    public function __construct(TokenFactory $tokenFactory)
    {
        $this->tokenFactory = $tokenFactory;
    }

    /**
     * @inheritDoc
     */
    function tokenize(ReaderInterface $reader): ArrayIterator
    {
        $reader->resetCursor();
        $tokens = [];
        while($reader->moveToNextToken())
        {
            $currentTokenName = $reader->getCurrentToken();
            $currentToken = $this->tokenFactory->getTokenByName($currentTokenName);
            $tokens[] = $currentToken;
        }
        return new ArrayIterator($tokens);
    }
}